@ECHO OFF
TITLE DNS Dump to HTML
ECHO DNS Dump to HTML
ECHO Written by: Jason Faulkner
ECHO SysadminGeek.com
ECHO.
ECHO.

SETLOCAL EnableDelayedExpansion

REM Directory where the HTML pages should be generated.
SET OutPath=C:\inetpub\wwwroot\dns
SET HTMLPage=default.htm

REM HTML page title/header.
SET Title=DNS Records

REM Delete DNS record files which are not currently loaded in the DNS server (1=Yes, 0=No)
SET DeleteNotFound=0


DEL /Q "%OutPath%\*"
SET OutFile="%OutPath%\%HTMLPage%"

REM HTML header info. Customize as needed.
ECHO ^<HTML^> >> %OutFile%
ECHO ^<HEAD^> >> %OutFile%
ECHO ^<TITLE^>%Title%^</TITLE^> >> %OutFile%
ECHO ^</HEAD^> >> %OutFile%
ECHO ^<BODY^> >> %OutFile%
ECHO ^<H1^>%Title%^<H1^> >> %OutFile%
ECHO ^<H3^>Machine Name: %ComputerName%^</H3^> >> %OutFile%
ECHO ^<H5^>Generated on: %Date% %Time%^</H5^> >> %OutFile%

SET DNSDir=%WinDir%\system32\dns
FOR /F %%A IN ('DIR /A:-D /B /L %DNSDir%\*.dns') DO (
	SET Zone=%%A
	SET Zone=!Zone:.dns=!
	SET ZoneFile=!Zone!.dns.zone.txt
	
	ECHO Exporting: !Zone!
	DNSCmd . /ZoneExport !Zone! !ZoneFile!
	
	IF NOT EXIST %DNSDir%\!ZoneFile! (
		ECHO !Zone! is not currently loaded in DNS Server.
		IF {%DeleteNotFound%}=={1} DEL /F /Q %DNSDir%\%%A
	) ELSE (
		ECHO ^<A HREF="!ZoneFile!"^>!Zone!^</A^>^<BR/^> >> %OutFile%
		REM Output is always to DNS directory, so move the file to the HTML dir.
		MOVE /Y %DNSDir%\!ZoneFile! "%OutPath%\!ZoneFile!"
	)
	ECHO.
)

ECHO ^<BR/^> >> %OutFile%
ECHO ^</BODY^> >> %OutFile%
ECHO ^</HTML^> >> %OutFile%

ENDLOCAL
